#include <stdio.h>

using namespace std;


int main()
{

    int n,q,i,l,r,j,k;
    scanf("%d %d",&n,&q);
    int a[n],h[q];
    for(i=0;i<n;i++)
        scanf("%d",&a[i]);
    for(i=0;i<q;i++)
    {
        scanf("%d %d",&l,&r);
        h[i] = a[l-1];
        while(l < r)
        {
            h[i] = h[i] & a[l] & a[r];
            l++;
            r--;
        }
    }
    for(i=0;i<q;i++)
        printf("%d\n",h[i]);
    return 0;
}